package com.njyunzhi.h5.common;

import com.njyunzhi.h5.config.WeixinConfig;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.api.impl.WxMpServiceImpl;
import me.chanjar.weixin.mp.config.WxMpConfigStorage;
import me.chanjar.weixin.mp.config.impl.WxMpDefaultConfigImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class WxUtils {
    private WxMpService mpService;

    @Autowired
    public WxUtils(WeixinConfig config) {
        WeixinConfig.Mp mp = config.getMp();
        WxMpDefaultConfigImpl wxMpDefaultConfig = new WxMpDefaultConfigImpl();
        wxMpDefaultConfig.setAppId(mp.getAppid());
        wxMpDefaultConfig.setSecret(mp.getSecret());
        wxMpDefaultConfig.setToken(mp.getToken());
        wxMpDefaultConfig.setAesKey(mp.getAesKey());

        if (null != mp.getHttpPoxyHost() && !"".equals(mp.getHttpPoxyHost())) {
            wxMpDefaultConfig.setHttpProxyHost(mp.getHttpPoxyHost());
            wxMpDefaultConfig.setHttpProxyPort(mp.getHttpProxyPort());
        }

        mpService = newMpService(wxMpDefaultConfig);
    }


    /**
     * 生成 公众号 服务
     * @param config
     * @return
     */
    public WxMpService newMpService(WxMpConfigStorage config) {
        WxMpService service = new WxMpServiceImpl();
        service.setWxMpConfigStorage(config);
        return service;
    }

    /**
     * 获取 公众号服务
     * @return
     */
    public WxMpService getMpService() {
        return mpService;
    }
}
